/****************************************************************************
*
* Authors:    Ondrej Lutera
* Copyright:  GPL
*
*
*****************************************************************************/

#include "adc.h"
#include <util/delay.h>

volatile uint8_t curr_chnl=NO_CH;

void initAD(void)
{

	ADCSRA= (1<<ADEN) | (1<< ADPS2) | (1<<ADPS1) | (1<<ADPS0);     /*8MHz/128 = 62,5kHz */

}

void StartAD(uint8_t chan)
{
 
    if(chan == NO_CH) return;

    while(bit_is_set(ADCSRA,ADSC));     /*  pockej pokud bezi prevod */

    ADMUX = REF | chan;
	
	_delay_us(2);

    ADCSRA|= (1<<ADSC);     			/*20MHz/128 = 150kHz */

    curr_chnl = chan;
}

uint16_t ReadAD(uint8_t chan){


    if(curr_chnl == chan){
        while(bit_is_set(ADCSRA,ADSC));     /*  pockej pokud bezi prevod */

        curr_chnl = NO_CH;			

        return ADC;
    }
    else return BAD_CH;

}
